<?php

/***************************************************************************\
 *  Plugin Statistiques pour les brves                          	   	 *
 *                                                                         *
 *  Copyright (c) 2007-2008                                                *
 *  Elrik - Peetdu														 *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
\***************************************************************************/

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/presentation');

function get_stats_breves() {
	$query = "SELECT id_breve, visites, titre, date_heure FROM spip_breves".
		" WHERE statut = 'publie' ORDER BY date_heure DESC LIMIT 50";
	$result = spip_query($query);
	$stats = array();
	while ($row = spip_fetch_array($result)) {
		$stats[] = $row;
	}
	return $stats;
}

function get_stats_breves_les_plus_populaires() {
	$query = "SELECT id_breve, visites, titre, date_heure FROM spip_breves".
		" WHERE statut = 'publie' ORDER BY visites DESC LIMIT 20";
	$result = spip_query($query);
	$stats = array();
	while ($row = spip_fetch_array($result)) {
		$stats[] = $row;
	}
	return $stats;
}


function html_stats_breves_tab() {

global
    $couleur_claire,
    $couleur_foncee;
		
	$stats = get_stats_breves();
	if (count($stats) == 0) {
		return "<p>"._T('aucune_breve_trouvee')."</p>";
	}
	$html = '<table width="100%" style="font-size:10px;">'."\n";
	$html .= '<tr bgcolor='.$couleur_foncee.'><th width="75%">Br&egrave;ve</th><th width="17%" style="text-align:center;">'._T('stbrv:date_creation').'</th>'.
		'<th  width="8%" style="text-align:right; ">'._T('stbrv:nombre_visites').'</th></tr>'."\n";
	for ($i=0; $i<count($stats); $i++) {
		$breve = $stats[$i];
		$html.='<tr class="tr_liste"><td><a href="?exec=stats_breves_detail&id_breve='.$breve['id_breve'].'">'.
			$breve['titre'].'</a></td>'."\n";
		$html.='<td style="text-align:center;">'.($breve['date_heure']?strftime('%d %b %Y',strtotime($breve['date_heure'])):'?').'</td>'."\n";
		$html.='<td style="text-align:right;">'.$breve['visites'].'</td>'."\n</tr>\n";
	}
	$html.='</table>'."\n";
	return $html;
}

function html_stats_breves_detail() {
	$stats = get_stats_breves_les_plus_populaires();
	if (count($stats) == 0) {
		return "<p>"._T('aucune_breve_trouvee')."</p>";
	}
	$html = "<ol style='padding-left:30px; font-size:x-small;color:#666666;'>\n";
	for ($i=0; $i<count($stats); $i++) {
		$breve = $stats[$i];
		$html .= '<li><a href="?exec=stats_breves_detail&id_breve='.$breve['id_breve'].'" title="">'.$breve['titre'].'</li>'."\n";
	}
	$html .= "</ol>\n";
	return $html;
}


// debut de la fonction principale
function exec_stats_breves_tableau()
{
  global
    $connect_statut,
    $couleur_claire,
    $couleur_foncee,
    $limit,
    $origine,
    $spip_lang_left;

  $style = "class='arial1 spip_x-small' style='color: #999999'";


	$commencer_page = charger_fonction('commencer_page', 'inc');
	echo $commencer_page(_T('statistiques_breves'), _T("statistiques_breves"), _T("statistiques"));
	echo "<br /><br />";
	gros_titre(_T("stbrv:statistiques_breves"));


	debut_gauche();
	
	echo "<div class='iconeoff' style='padding: 5px;'>";
	echo "<div style='font-size:small;' class='verdana1'>";
	echo typo(_T('info_afficher_visites'));
	echo "<ul>";
	echo "<li><b><a href='" . generer_url_ecrire("statistiques_visites","") . "'>"._T('info_tout_site')."</a></b></li>";
	echo "</ul>";
	echo "</div>";
	echo "</div>";
	
	echo "<br /><div class='iconeoff' style='padding: 5px;'>";
	echo "<div style='font-size:small;overflow:hidden;' class='verdana1'>";
	echo typo(_T('stbrv:breves_les_plus_visites'));
	echo html_stats_breves_detail();
	echo "</div>";
	
	debut_droite();
		
	//le tableau  barres horizontales
	debut_cadre_relief("statistiques-24.gif");
		echo html_stats_breves_tab();
	fin_cadre_relief("");
	
	debut_boite_info();
	echo "Info : Explication sur les statistiques des breves.\n";
	fin_boite_info();



echo fin_gauche(), fin_page();
 } // fin fonction
?>
